#include <iostream> // Stream-basierte Ein-/Ausgabe kommt noch
#include <string> // String"klasse" kommt noch

using namespace std; // wegen neuer Standard-Header (die ohne .h) ntig
                     // Dev-C++ (also mingw) kommt auch ohne aus.

#define AUSGABE(x) cout << (x) << endl; // Dieses bitte erst mal ignorieren.

class TestA
{
    private:
    string mname; // String-Objekt fr Name
    int mgroesse;
    int* p; // zeigt nachher auf ein eindim. int-Array mit Gre mgroesse

    public:
    TestA (string name, int groesse) // Konstruktor
    {
        mname = name; // Initialisierung ist noch nicht schn, nachher besser
        mgroesse = groesse;
        p = new int[mgroesse];
        AUSGABE(mname+" ist konstruiert.")
    }

    TestA (void) // NEU: parameterloser Konstruktor
    {
        mname = "NN";
        mgroesse = 13;
        p = new int[mgroesse];
        AUSGABE(mname+" wird konstruiert.")
    }

    ~TestA() // Destruktor (in Java: finalize(), braucht man da aber selten,
             // dank automatischer Garbage Collection)
    {
        delete[] p;
        // Desktruktor fr mgroesse wird automatisch aufgerufen.
        AUSGABE(mname+" wird destruiert.")
    }

    void setze (int wo, int wert)
    {
        p[wo] = wert;
        AUSGABE("aus "+mname+" gesetzt")
    }

    void setze (int wo) // NEU: andere Parameter
    {
        p[wo] = 0;
        AUSGABE("aus "+mname+" kurz gesetzt")
    }

    int lese (int wo)
    {
        AUSGABE("aus "+mname+" gelesen")
        return p[wo];
    }
};

// In Terminal- bzw. Eingabefenster laufen lassen!
int main (int argc, char* (argv[]))
{
    TestA abc("abc",20);
    abc.setze(10,42);
    abc.setze(11);
    TestA bcd[3]; // dank parameterlosem Konstruktor mglich
    bcd[2].setze(10);
    TestA cde; // dank parameterlosem Konstruktor mglich
    // TestA cde();   wre kein!!! Konstruktoraufruf, sondern die
    //                die Deklaration einer parameterlosen Funktion cde,
    //                die ein Objekt vom Typ TestA zurckliefert.
    return 0;
}

/* "berladen von Funktionen/Methoden": selber Name, andere Parameter.
    Compiler whlt die richtige Funktion (meist ;-)

    TestA (string name, int groesse);
    TestA (void);

    void setze (int wo, int wert);
    void setze (int wo);
*/

// Damit verwandt: Default-Parameter

void test (int a, string b = "xyz", double c = 3.14)
{
}

void rufeDasAuf (void)
{
    test (12, "fgh", 2.718);
    test (12, "fgh"); // liefert test (12, "fgh", 3.14);
    test (12); // liefert test (12, "xyz", 3.14);
}


