#include <iostream> // Stream-basierte Ein-/Ausgabe kommt noch
#include <string> // String"klasse" kommt noch

using namespace std; // wegen neuer Standard-Header (die ohne .h) ntig
                     // Dev-C++ (also mingw) kommt auch ohne aus.

#define AUSGABE(x) cout << (x) << endl; // Dieses bitte erst mal ignorieren.

class TestA
{
    private:
    string mname; // String-Objekt fr Name
    int mgroesse;
    int* p; // zeigt nachher auf ein eindim. int-Array mit Gre mgroesse

    public:
    TestA(string name, int groesse) // Konstruktor
    {
        mname = name; // Initialisierung ist noch nicht schn, nachher besser
        mgroesse = groesse;
        p = new int[mgroesse];
        AUSGABE(mname+" wird konstruiert.")
    }

    ~TestA() // Destruktor (in Java: finalize(), braucht man da aber selten,
             // dank automatischer Garbage Collection)
    {
        delete[] p;
        // Desktruktor fr mgroesse wird automatisch aufgerufen.
        AUSGABE(mname+" wird destruiert.")
    }

    void setze(int wo, int wert)
    {
        p[wo] = wert;
        AUSGABE("aus "+mname+" gesetzt")
    }

    int lese(int wo)
    {
        return p[wo];
        AUSGABE("aus "+mname+" gelesen")
    }
};

// In Terminal- bzw. Eingabefenster laufen lassen!
int main (int argc, char* (argv[]))
{
    TestA abc("abc",20);  // statt   TestA abc = TestA("abc",20);
    abc.setze(10,42);
    int k;
    for (k=0; k<5; k++)
    {
        TestA bcd("bcd",14);
        bcd.setze(10,42);
    }
    k = abc.lese(10);
    return 0;
}

void test (void)
{
    //!  TestA cde[34];  // compiliert nicht, weil eigener Konstruktor,
                         // aber nur mit Parametern
    //!  TestA edf;      // selbes Problem
                         // Besser im nchsten Programm!
}
